/*
  File autogenerated by gengetopt version 2.13.1
  generated with the following command:
  gengetopt -u --conf-parser --file-name=gui.cmdline 

  The developers of gengetopt consider the fixed text that goes in all
  gengetopt output files to be in the public domain:
  we make no copyright claims on it.
*/

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "getopt.h"

#include "gui.cmdline.h"

static
void clear_given (struct gengetopt_args_info *args_info);
static
void clear_args (struct gengetopt_args_info *args_info);

static int
cmdline_parser_internal (int argc, char * const *argv, struct gengetopt_args_info *args_info, int override, int initialize, int check_required, const char *additional_error);


struct key_map_list
{
  char * key_map_arg;
  struct key_map_list * next;
};

static char *
gengetopt_strdup (const char *s);

static
void clear_given (struct gengetopt_args_info *args_info)
{
  args_info->help_given = 0 ;
  args_info->version_given = 0 ;
  args_info->auto_decode_given = 0 ;
  args_info->config_file_given = 0 ;
  args_info->loglevel_given = 0 ;
  args_info->timeout_given = 0 ;
  args_info->stat_cmd_given = 0 ;
  args_info->key_map_given = 0 ;
}

static
void clear_args (struct gengetopt_args_info *args_info)
{
  args_info->auto_decode_flag = 1;
  args_info->config_file_arg = NULL;
  args_info->loglevel_arg = 4 ;
  args_info->timeout_arg = 300 ;
  args_info->stat_cmd_arg = gengetopt_strdup ("para_audioc -t 100 stat");
  args_info->key_map_arg = NULL;
}

void
cmdline_parser_print_version (void)
{
  printf ("%s %s\n", CMDLINE_PARSER_PACKAGE, CMDLINE_PARSER_VERSION);
}

void
cmdline_parser_print_help (void)
{
  cmdline_parser_print_version ();
  printf("\nUsage: para_gui [OPTIONS]... [FILES]...\n\n");
  printf("%s\n","  -h, --help                  Print help and exit");
  printf("%s\n","  -V, --version               Print version and exit");
  printf("%s\n","\ngeneral options:");
  printf("%s\n","  -a, --auto_decode           auto-decode audio stream  (default=on)");
  printf("%s\n","  -c, --config_file=filename  (default='~/.paraslash/gui.conf')");
  printf("%s\n","  -l, --loglevel=level        set loglevel (0-6)  (default=`4')");
  printf("%s\n","  -t, --timeout=milliseconds  set timeout  (default=`300')");
  printf("%s\n","  -s, --stat_cmd=command      command to read server and audiod status data \n                                from  (default=`para_audioc -t 100 stat')");
  printf("%s\n","\nmapping keys to commands:");
  printf("%s\n","  -k, --key_map=k:m:c         Map key k to command c using mode m. Mode may be \n                                d, x or p for display, external and paraslash \n                                commands, respectively. Of course, this option \n                                may be given multiple times, one for each key \n                                mapping.");
  
}

void
cmdline_parser_init (struct gengetopt_args_info *args_info)
{
  clear_given (args_info);
  clear_args (args_info);

  args_info->inputs = NULL;
  args_info->inputs_num = 0;
}

void
cmdline_parser_free (struct gengetopt_args_info *args_info)
{
  
  unsigned int i;
  if (args_info->config_file_arg)
    {
      free (args_info->config_file_arg); /* free previous argument */
      args_info->config_file_arg = 0;
    }
  if (args_info->stat_cmd_arg)
    {
      free (args_info->stat_cmd_arg); /* free previous argument */
      args_info->stat_cmd_arg = 0;
    }
  if (args_info->key_map_arg)
    {
      for (i = 0; i < args_info->key_map_given; ++i)
        {
          if (args_info->key_map_arg [i])
            {
              free (args_info->key_map_arg [i]); /* free previous argument */
              args_info->key_map_arg [i] = 0;
            }
        }
      if (args_info->key_map_arg [0])
        free (args_info->key_map_arg [0]); /* free default string */
      free (args_info->key_map_arg); /* free previous argument */
      args_info->key_map_arg = 0;
    }
  
  for (i = 0; i < args_info->inputs_num; ++i)
    free (args_info->inputs [i]);
  
  if (args_info->inputs_num)
    free (args_info->inputs);
  
  clear_given (args_info);
}

/* gengetopt_strdup() */
/* strdup.c replacement of strdup, which is not standard */
char *
gengetopt_strdup (const char *s)
{
  char *result = NULL;
  if (!s)
    return result;

  result = (char*)malloc(strlen(s) + 1);
  if (result == (char*)0)
    return (char*)0;
  strcpy(result, s);
  return result;
}

static char *
get_multiple_arg_token(const char *arg)
{
  char *tok, *ret;
  size_t len;

  if (!arg)
    return NULL;

  tok = strchr (arg, ',');

  if (tok)
    len = (size_t)(tok - arg + 1);
  else
    len = strlen (arg) + 1;

  ret = (char *) malloc (len);
  strncpy (ret, arg, len-1);
  ret[len-1] = '\0';

  return ret;
}

static char *
get_multiple_arg_token_next(const char *arg)
{
  char *tok;

  if (!arg)
    return NULL;

  tok = strchr (arg, ',');

  if (! tok || strlen(tok) == 1)
    return 0;

  return tok+1;
}

int
cmdline_parser (int argc, char * const *argv, struct gengetopt_args_info *args_info)
{
  return cmdline_parser2 (argc, argv, args_info, 0, 1, 1);
}

int
cmdline_parser2 (int argc, char * const *argv, struct gengetopt_args_info *args_info, int override, int initialize, int check_required)
{
  int result;

  result = cmdline_parser_internal (argc, argv, args_info, override, initialize, check_required, NULL);

  if (result == EXIT_FAILURE)
    {
      cmdline_parser_free (args_info);
      exit (EXIT_FAILURE);
    }
  
  return result;
}

int
cmdline_parser_required (struct gengetopt_args_info *args_info, const char *prog_name)
{
  return EXIT_SUCCESS;
}

int
cmdline_parser_internal (int argc, char * const *argv, struct gengetopt_args_info *args_info, int override, int initialize, int check_required, const char *additional_error)
{
  int c;	/* Character of the parsed option.  */
  char *multi_token, *multi_next; /* for multiple options */

  int i;        /* Counter */

  struct key_map_list * key_map_list = NULL,* key_map_new = NULL;
  int error = 0;
  struct gengetopt_args_info local_args_info;

  if (initialize)
    cmdline_parser_init (args_info);

  cmdline_parser_init (&local_args_info);

  optarg = 0;
  optind = 1;
  opterr = 1;
  optopt = '?';

  while (1)
    {
      int option_index = 0;
      char *stop_char;

      static struct option long_options[] = {
        { "help",	0, NULL, 'h' },
        { "version",	0, NULL, 'V' },
        { "auto_decode",	0, NULL, 'a' },
        { "config_file",	1, NULL, 'c' },
        { "loglevel",	1, NULL, 'l' },
        { "timeout",	1, NULL, 't' },
        { "stat_cmd",	1, NULL, 's' },
        { "key_map",	1, NULL, 'k' },
        { NULL,	0, NULL, 0 }
      };

      stop_char = 0;
      c = getopt_long (argc, argv, "hVac:l:t:s:k:", long_options, &option_index);

      if (c == -1) break;	/* Exit from `while (1)' loop.  */

      switch (c)
        {
        case 'h':	/* Print help and exit.  */
          cmdline_parser_print_help ();
          cmdline_parser_free (&local_args_info);
          exit (EXIT_SUCCESS);

        case 'V':	/* Print version and exit.  */
          cmdline_parser_print_version ();
          cmdline_parser_free (&local_args_info);
          exit (EXIT_SUCCESS);

        case 'a':	/* auto-decode audio stream.  */
          if (local_args_info.auto_decode_given)
            {
              fprintf (stderr, "%s: `--auto_decode' (`-a') option given more than once%s\n", argv[0], (additional_error ? additional_error : ""));
              goto failure;
            }
          if (args_info->auto_decode_given && ! override)
            continue;
          local_args_info.auto_decode_given = 1;
          args_info->auto_decode_given = 1;
          args_info->auto_decode_flag = !(args_info->auto_decode_flag);
          break;

        case 'c':	/* (default='~/.paraslash/gui.conf').  */
          if (local_args_info.config_file_given)
            {
              fprintf (stderr, "%s: `--config_file' (`-c') option given more than once%s\n", argv[0], (additional_error ? additional_error : ""));
              goto failure;
            }
          if (args_info->config_file_given && ! override)
            continue;
          local_args_info.config_file_given = 1;
          args_info->config_file_given = 1;
          if (args_info->config_file_arg)
            free (args_info->config_file_arg); /* free previous string */
          args_info->config_file_arg = gengetopt_strdup (optarg);
          break;

        case 'l':	/* set loglevel (0-6).  */
          if (local_args_info.loglevel_given)
            {
              fprintf (stderr, "%s: `--loglevel' (`-l') option given more than once%s\n", argv[0], (additional_error ? additional_error : ""));
              goto failure;
            }
          if (args_info->loglevel_given && ! override)
            continue;
          local_args_info.loglevel_given = 1;
          args_info->loglevel_given = 1;
          args_info->loglevel_arg = strtol (optarg,&stop_char,0);
          break;

        case 't':	/* set timeout.  */
          if (local_args_info.timeout_given)
            {
              fprintf (stderr, "%s: `--timeout' (`-t') option given more than once%s\n", argv[0], (additional_error ? additional_error : ""));
              goto failure;
            }
          if (args_info->timeout_given && ! override)
            continue;
          local_args_info.timeout_given = 1;
          args_info->timeout_given = 1;
          args_info->timeout_arg = strtol (optarg,&stop_char,0);
          break;

        case 's':	/* command to read server and audiod status data from.  */
          if (local_args_info.stat_cmd_given)
            {
              fprintf (stderr, "%s: `--stat_cmd' (`-s') option given more than once%s\n", argv[0], (additional_error ? additional_error : ""));
              goto failure;
            }
          if (args_info->stat_cmd_given && ! override)
            continue;
          local_args_info.stat_cmd_given = 1;
          args_info->stat_cmd_given = 1;
          if (args_info->stat_cmd_arg)
            free (args_info->stat_cmd_arg); /* free previous string */
          args_info->stat_cmd_arg = gengetopt_strdup (optarg);
          break;

        case 'k':	/* Map key k to command c using mode m. Mode may be d, x or p for display, external and paraslash commands, respectively. Of course, this option may be given multiple times, one for each key mapping..  */
          local_args_info.key_map_given++;
        
          multi_token = get_multiple_arg_token(optarg);
          multi_next = get_multiple_arg_token_next (optarg);
        
          while (1)
            {
              key_map_new = (struct key_map_list *) malloc (sizeof (struct key_map_list));
              key_map_new->next = key_map_list;
              key_map_list = key_map_new;
              key_map_new->key_map_arg = multi_token;
        
              if (multi_next)
                {
                  multi_token = get_multiple_arg_token(multi_next);
                  multi_next = get_multiple_arg_token_next (multi_next);
                  local_args_info.key_map_given++;
                }
              else
                break;
            }
          break;


        case 0:	/* Long option with no short option */
        case '?':	/* Invalid option.  */
          /* `getopt_long' already printed an error message.  */
          goto failure;

        default:	/* bug: option not considered.  */
          fprintf (stderr, "%s: option unknown: %c%s\n", CMDLINE_PARSER_PACKAGE, c, (additional_error ? additional_error : ""));
          abort ();
        } /* switch */
    } /* while */


  if (local_args_info.key_map_given && key_map_list)
    {
      struct key_map_list *tmp;
      args_info->key_map_arg = (char * *) realloc (args_info->key_map_arg, (args_info->key_map_given + local_args_info.key_map_given) * sizeof (char *));
      for (i = (local_args_info.key_map_given - 1); i >= 0; --i)
        {
          tmp = key_map_list;
          args_info->key_map_arg [i + args_info->key_map_given] = key_map_list->key_map_arg;
          key_map_list = key_map_list->next;
          free (tmp);
        }
    }
  

  args_info->key_map_given += local_args_info.key_map_given;
  local_args_info.key_map_given = 0;
  

  cmdline_parser_free (&local_args_info);

  if ( error )
    return (EXIT_FAILURE);

  if (optind < argc)
    {
      int i = 0 ;

      args_info->inputs_num = argc - optind ;
      args_info->inputs =
        (char **)(malloc ((args_info->inputs_num)*sizeof(char *))) ;
      while (optind < argc)
        args_info->inputs[ i++ ] = gengetopt_strdup (argv[optind++]) ;
    }

  return 0;

failure:
  if (key_map_list)
    {
      struct key_map_list *tmp;
      while (key_map_list)
        {
          tmp = key_map_list;
          free (key_map_list->key_map_arg);
          key_map_list = key_map_list->next;
          free (tmp);
        }
    }
  
  cmdline_parser_free (&local_args_info);
  return (EXIT_FAILURE);
}

#define CONFIGPARSERBUFSIZE 256
#define ADDITIONAL_ERROR " in configuration file "

#define CONF_FILE_LINES 256
#define CONF_FILE_STRING (CONFIGPARSERBUFSIZE+3)
/* 3 is for "--" and "=" */

typedef char buffer_line_t[CONF_FILE_LINES];

buffer_line_t
my_argv[CONF_FILE_STRING];

int
cmdline_parser_configfile (char * const filename, struct gengetopt_args_info *args_info, int override, int initialize, int check_required)
{
  FILE* file;
  char linebuf[CONFIGPARSERBUFSIZE];
  int line_num = 0;
  int i, result, equal;
  char *fopt, *farg;
  char *str_index;
  size_t len, next_token;
  char delimiter;
  int my_argc = 0;
  char **my_argv_arg;
  char *additional_error;

  strcpy (my_argv[0], CMDLINE_PARSER_PACKAGE);
  for (i = 1; i < CONF_FILE_LINES; ++i)
    my_argv[i][0] = '\0';

  if ((file = fopen(filename, "r")) == NULL)
    {
      fprintf (stderr, "%s: Error opening configuration file '%s'\n",
               CMDLINE_PARSER_PACKAGE, filename);
      result = EXIT_FAILURE;
      goto conf_failure;
    }

  while ((fgets(linebuf, CONFIGPARSERBUFSIZE, file)) != NULL)
    {
      ++line_num;
      len = strlen(linebuf);
      if (len > (CONF_FILE_STRING-1))
        {
          fprintf (stderr, "%s:%s:%d: Line too long in configuration file\n",
                   CMDLINE_PARSER_PACKAGE, filename, line_num);
          result = EXIT_FAILURE;
          goto conf_failure;
        }

      /* find first non-whitespace character in the line */
      next_token = strspn ( linebuf, " \t\r\n");
      str_index  = linebuf + next_token;

      if ( str_index[0] == '\0' || str_index[0] == '#')
        continue; /* empty line or comment line is skipped */

      fopt = str_index;

      /* truncate fopt at the end of the first non-valid character */
      next_token = strcspn (fopt, " \t\r\n=");

      if (fopt[next_token] == '\0') /* the line is over */
        {
          farg  = NULL;
          equal = 0;
          goto noarg;
        }

      /* remember if equal sign is present */
      equal = (fopt[next_token] == '=');
      fopt[next_token++] = '\0';

      /* advance pointers to the next token after the end of fopt */
      next_token += strspn (fopt + next_token, " \t\r\n");
      /* check for the presence of equal sign, and if so, skip it */
      if ( !equal )
        if ((equal = (fopt[next_token] == '=')))
          {
            next_token++;
            next_token += strspn (fopt + next_token, " \t\r\n");
          }
      str_index  += next_token;

      /* find argument */
      farg = str_index;
      if ( farg[0] == '\"' || farg[0] == '\'' )
        { /* quoted argument */
          str_index = strchr (++farg, str_index[0] ); /* skip opening quote */
          if (! str_index)
            {
              fprintf
                (stderr,
                 "%s:%s:%d: unterminated string in configuration file\n",
                 CMDLINE_PARSER_PACKAGE, filename, line_num);
              result = EXIT_FAILURE;
              goto conf_failure;
            }
        }
      else
        { /* read up the remaining part up to a delimiter */
          next_token = strcspn (farg, " \t\r\n#\'\"");
          str_index += next_token;
        }

      /* truncate farg at the delimiter and store it for further check */
      delimiter = *str_index, *str_index++ = '\0';

      /* everything but comment is illegal at the end of line */
      if (delimiter != '\0' && delimiter != '#')
        {
          str_index += strspn(str_index, " \t\r\n");
          if (*str_index != '\0' && *str_index != '#')
            {
              fprintf
                (stderr,
                 "%s:%s:%d: malformed string in configuration file\n",
                 CMDLINE_PARSER_PACKAGE, filename, line_num);
              result = EXIT_FAILURE;
              goto conf_failure;
            }
        }

    noarg:
      ++my_argc;
      len = strlen(fopt);

      strcat (my_argv[my_argc], len > 1 ? "--" : "-");
      strcat (my_argv[my_argc], fopt);
      if (len > 1 && ((farg &&*farg) || equal))
            strcat (my_argv[my_argc], "=");
      if (farg && *farg)
          strcat (my_argv[my_argc], farg);
    } /* while */

  ++my_argc; /* for program name */
  my_argv_arg = (char **) malloc((my_argc+1) * sizeof(char *));
  for (i = 0; i < my_argc; ++i)
    my_argv_arg[i] = my_argv[i];
  my_argv_arg[my_argc] = 0;

  additional_error = (char *)malloc(strlen(filename) + strlen(ADDITIONAL_ERROR) + 1);
  strcpy (additional_error, ADDITIONAL_ERROR);
  strcat (additional_error, filename);
  result =
    cmdline_parser_internal (my_argc, my_argv_arg, args_info, override, initialize, check_required, additional_error);

  free (additional_error);
  free (my_argv_arg);

conf_failure:
  if (file)
    fclose(file);
  if (result == EXIT_FAILURE)
    {
      cmdline_parser_free (args_info);
      exit (EXIT_FAILURE);
    }
  
  return result;
}
